local gsub = gsub
local format = format
local strsub = strsub
local strfind = strfind
local strmatch = strmatch
local strrev = string.reverse
local tonumber = tonumber
local GetMapInfo = C_ChallengeMode.GetMapInfo

local ReformatKeys = function(self, event, msg, ...)
	if strfind(msg, "\124Hitem:138019:") then -- A keystone!
		-- If someone better with string manipulation can do this in a cleaner fashion, I'm not ashamed to take help!
		local ItemLinkStart, ItemLinkStop = strfind(msg, "\124cffa335ee\124Hitem:138019:([0-9:]+)\124h(.-)\124h\124r")
		local ItemLink = strsub(msg, ItemLinkStart, ItemLinkStop)
		local LinkString = strmatch(ItemLink, "\124H(.-)\124h")
		local KeyName = strmatch(ItemLink, "\124h%[(.-)%]\124h")
		local IsDepleted = strmatch(strrev(LinkString), ":::(%d+):") ~= "1"
		local DungeonID, DungeonLevel = strmatch(LinkString, "item:138019::::::::%d+:%d+:%d+:::(%d+):(%d+)")
		local DungeonName = GetMapInfo(tonumber(DungeonID))
		
		if (DungeonName and DungeonLevel) then
			local LinkName
			
			if IsDepleted then
				LinkName = format("%s %s (%s)", DungeonName, DungeonLevel, CHALLENGE_MODE_KEYSTONE_DEPLETED)
			else
				LinkName = format("%s %s", DungeonName, DungeonLevel)
			end
			
			LinkName = format(CHALLENGE_MODE_KEYSTONE_NAME, LinkName)
			
			msg = gsub(msg, KeyName, LinkName)
			
			return false, msg, ...
		end
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_LEADER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", ReformatKeys)